import numpy as np
import copy


def encolar(q, sol):
    i=0
    while i<len(q) and sol[0]>=q[i][0]:
        i+=1
    q = q[:i] + [sol] + q[i:]
    return q

def desencolar(q):
    return [q[0], q[1:]]

def crearColaVacia():
    return []

def esColaVacia(q):
    return q == []

def calculaCoste(solucion,costeTareas):
    tupla = solucion[1]
    longitud = solucion[2]
    coste = 0
    for i in range(longitud):
        coste += costeTareas[i,tupla[i]]
    estimacion = 0
    for agente in range(longitud,len(costeTareas)):
        minCoste = np.inf
        for tarea in range(len(costeTareas)):
            if tarea not in tupla[0:longitud] and costeTareas[agente,tarea] < minCoste:
                minCoste = costeTareas[agente,tarea]
        estimacion += minCoste
    solucion[0] = coste + estimacion
    return solucion


def SolucionInicial(costeTareas):
    long = len(costeTareas)
    sol = [0, np.array(list(range(long)),dtype=int),long]
    sol = calculaCoste(sol,costeTareas)
    return sol

def GenerarTuplaVacia(costeTareas):
    long = len(costeTareas)
    sol = [0, np.zeros(long,dtype=int), 0]
    sol = calculaCoste(sol, costeTareas)
    return sol

def esSolucion(sol,n):
    return sol[2] == n

def esMejor(sol1, sol2):
    return sol1[0] < sol2[0]

def esta(tarea,sol):
    tupla = sol[1]
    long = sol[2]
    return tarea in tupla[0:long]


def asignar(sol,valor, tareas):
    longitud = sol[2]
    sol[1][longitud] = valor # Se asigna nuevo valor
    sol[2] += 1 # Se aumenta la longitud
    sol = calculaCoste(sol, tareas)
    return sol

def compleccionesFactibles(sol, costeTareas):
    listaHijos = []
    for tarea in range(len(costeTareas)):
        hijo = copy.deepcopy(sol) # Genera una copia de listas y sublistas
        if not esta(tarea,sol): # Solo generamos soluciones factibles
            hijo = asignar(hijo,tarea,costeTareas)
            listaHijos.append(hijo)
    return listaHijos


def RamificacionYPoda(costeTareas):
    n = len(costeTareas)
    solMejor = SolucionInicial(costeTareas)
    sol = GenerarTuplaVacia(costeTareas) # Tupla parcial inicialmente vacía
    q = crearColaVacia()
    q = encolar(q, sol)  # se añade la sol inicial
    while not esColaVacia(q):
        [sol, q] = desencolar(q)  # Sol es el nodo de prioridad max
        if esSolucion(sol, n):
            if esMejor(sol, solMejor):
                solMejor = sol  # Se actualiza SolMejor
        else:
            if esMejor(sol, solMejor):  # Criterio de poda
                hijos = compleccionesFactibles(sol, costeTareas)
                for hijo in hijos:
                    if esMejor(hijo, solMejor):
                        q = encolar(q, hijo)
    return solMejor





# Prog Ppal:
costeTareas=np.array([[11,12,18,40],[14,15,13,22],[11,17,19,23],[17,14,20,28]])
solucion = RamificacionYPoda(costeTareas)
print('La mejor solucion es:',solucion[1]+1)
print('Con coste:',solucion[0])