import numpy as np
import copy

def encolar(q, sol):
    i=0
    while i<len(q) and sol[0]>=q[i][0]:
        i+=1
    q = q[:i] + [sol] + q[i:]
    return q

def desencolar(q):
    return [q[0], q[1:]]

def crearColaVacia():
    return []

def esColaVacia(q):
    return q == []

def esSolucion(sol,n):
    return sol[2] == n

def esMejor(sol1, sol2):
    return sol1[0] < sol2[0]

def calculaCoste(solucion,Distancias):
    n = len(Distancias)
    tupla = solucion[1]
    tope = solucion[2]
    longCamino = 0
    # Longitud del camino construido hasta el momento:
    for i in range(tope-1):
        longCamino += Distancias[tupla[i],tupla[i+1]]
    if tope == n: # Si ya tengo una solución completa:
        longCamino += Distancias[0,tupla[tope-1]]
        solucion[0] = longCamino
    else: # Si la tupla no es completa, estimamos:
        estimacion = 0
        for i in range(n):
            if i not in tupla[0:tope]:
                estimacion += min(Distancias[i])
        estimacion += min(Distancias[0]) # Hay que volver al origen
        solucion[0] = longCamino + estimacion
    return solucion

def GenerarTuplaVacia(Distancias):
    # La solución es una colección formada por: [Valor Func Coste, tupla, longitud]
    n = len(Distancias)
    solucion = [0, np.zeros(n,dtype=int), 1] # La longitud es 1 porque el nodo inicial es el 0
    solucion = calculaCoste(solucion, Distancias)
    return solucion

def esta(nodo,sol):
    tupla = sol[1]
    long = sol[2]
    return nodo in tupla[0:long]

def asignar(sol,valor, tareas):
    longitud = sol[2]
    sol[1][longitud] = valor # Se asigna nuevo valor
    sol[2] += 1 # Se aumenta la longitud
    sol = calculaCoste(sol, tareas)
    return sol

def compleccionesFactibles(sol, Distancias):
    n = len(Distancias)
    listaHijos = []
    for nodo in range(n):
        hijo = copy.deepcopy(sol) # Genera una copia de listas y sublistas
        if not esta(nodo,sol): # Solo generamos soluciones factibles
            hijo = asignar(hijo,nodo,Distancias)
            listaHijos.append(hijo)
    return listaHijos

def seleccionar(sol, candidatos,Distancias):
    ultimoNodo = sol[1][sol[2]-1]
    sel = candidatos[0]
    distMenor = Distancias[ultimoNodo,sel]
    posMenor = 0
    for i in range(1,len(candidatos)):
        if Distancias[ultimoNodo,candidatos[i]]<distMenor:
            sel = candidatos[i]
            distMenor = Distancias[ultimoNodo, i]
            posMenor = i
    del candidatos[posMenor]
    return sel, candidatos

def SolucionInicial(Distancias):
    n = len(Distancias)
    sol = GenerarTuplaVacia(Distancias)
    candidatos = list(range(1,n))
    while candidatos != []:
        [nodoSig, candidatos] = seleccionar(sol, candidatos,Distancias)
        sol[1][sol[2]] = nodoSig
        sol[2] += 1
    calculaCoste(sol,Distancias)
    return sol

def RamificacionYPoda(Distancias):
    n = len(Distancias)
    solMejor = SolucionInicial(Distancias) # Algoritmo voraz
    sol = GenerarTuplaVacia(Distancias) # Tupla parcial inicialmente vacía
    q = crearColaVacia()
    q = encolar(q, sol) # se añade la sol inicial
    while not esColaVacia(q):
        [sol, q] = desencolar(q) # Sol es el nodo de prioridad max
        if esSolucion(sol,n):
            if esMejor(sol, solMejor):
                solMejor = sol # Se actualiza SolMejor
        else:
            if esMejor(sol, solMejor): # Criterio de poda
                hijos = compleccionesFactibles(sol,Distancias)
                for hijo in hijos:
                    if esMejor(hijo, solMejor):
                        q = encolar(q,hijo)
    return solMejor


# Prog ppal:
Distancias = np.array([[np.inf,     5,      7.07, 16.55, 15.52,    18],
                       [5,     np.inf,         5, 11.70, 11.05, 14.32],
                       [7.07,  5,         np.inf,    14, 14.32, 18.38],
                       [16.55, 11.70,    14,     np.inf,     3,   7.6],
                       [15.52, 11.05, 14.32,     3,     np.inf,     5],
                       [18,    14.32, 18.38,   7.6,     5,     np.inf]],dtype='float')
sol = RamificacionYPoda(Distancias)
print('La mejor solucion es:',sol[1])
print('Con valor:',sol[0])
