import numpy as np
import copy

def encolar(q, sol):
    i=0
    while i<len(q) and sol[0]>=q[i][0]:
        i+=1
    q = q[:i] + [sol] + q[i:]
    return q

def desencolar(q):
    return [q[0], q[1:]]

def crearColaVacia():
    return []

def esColaVacia(q):
    return q == []

def seleccionarNodo(sol,candidatos,Distancias):
    ultimoNodo = sol[1][sol[2]-1]
    nodoMejor = candidatos[0]
    distNodoMejor = Distancias[nodoMejor,ultimoNodo]
    indiceNodoMejor = 0
    for i in range(1,len(candidatos)):
        if Distancias[ultimoNodo,candidatos[i]] < distNodoMejor:
            nodoMejor = candidatos[i]
            indiceNodoMejor = i
            distNodoMejor = Distancias[ultimoNodo,candidatos[i]]
    del candidatos[indiceNodoMejor]
    return [nodoMejor, candidatos]

def calculaCoste(sol,Distancias):
    n = len(Distancias)
    tope = sol[2]
    tupla = sol[1]
    longitud = 0
    for i in range(0,tope-1):
        longitud += Distancias[tupla[i],tupla[i+1]]
    estimacion = 0
    if tope == n: # Si es solución:
        longitud += Distancias[tupla[tope-1],0]
    else:
        for i in range(n):
            if i not in tupla[0:tope]:
                estimacion += min(Distancias[i])
        estimacion += min(Distancias[0])
    sol[0] = longitud + estimacion
    return sol


def SolucionInicialVoraz(Distancias):
    # sol va a ser una lista con [coste,tupla,longitud]
    n = len(Distancias)
    sol = [0, np.zeros(n,dtype=int), 1]
    candidatos = list(range(1,n))
    while candidatos != []:
        [nodoSig, candidatos] = seleccionarNodo(sol,candidatos,Distancias)
        sol[1][sol[2]] = nodoSig
        sol[2] += 1
    sol = calculaCoste(sol,Distancias)
    return sol

def GenerarTuplaVacia(Distancias):
    # sol va a ser una lista con [coste,tupla,longitud]
    n = len(Distancias)
    sol = [0, np.zeros(n,dtype=int), 1]
    sol = calculaCoste(sol, Distancias)
    return sol

def esSolucion(sol,n):
    return sol[2] == n

def esMejor(sol1, sol2):
    return sol1[0] < sol2[0]

def compleccionesFactibles(sol,Distancias):
    n = len(Distancias)
    hijos =[]
    for nodo in range(n):
        if nodo not in sol[1]:
            hijo = copy.deepcopy(sol)
            hijo[1][hijo[2]] = nodo # Asignar el nuevo nodo
            hijo[2] += 1 # Aumentamos el tope
            hijo = calculaCoste(hijo, Distancias) # Actualizamos el tope
            hijos.append(hijo)
    return hijos

def RamificacionYPoda(Distancias):
    n = len(Distancias)
    solMejor = SolucionInicialVoraz(Distancias) # Algoritmo voraz
    sol = GenerarTuplaVacia(Distancias) # Tupla parcial inicialmente vacía
    q = crearColaVacia()
    q = encolar(q, sol) # se añade la sol inicial
    while not esColaVacia(q):
        [sol, q] = desencolar(q) # Sol es el nodo de prioridad max
        if esSolucion(sol,n):
            if esMejor(sol, solMejor):
                solMejor = sol # Se actualiza SolMejor
        else:
            if esMejor(sol, solMejor): # Criterio de poda
                hijos = compleccionesFactibles(sol,Distancias)
                for hijo in hijos:
                    if esMejor(hijo, solMejor):
                        q = encolar(q,hijo)
    return solMejor

# Prog Ppal:
Distancias = np.array([[np.inf,     5,      7.07, 16.55, 15.52,    18],
                       [5,     np.inf,         5, 11.70, 11.05, 14.32],
                       [7.07,  5,         np.inf,    14, 14.32, 18.38],
                       [16.55, 11.70,    14,     np.inf,     3,   7.6],
                       [15.52, 11.05, 14.32,     3,     np.inf,     5],
                       [18,    14.32, 18.38,   7.6,     5,     np.inf]],dtype='float')
sol = RamificacionYPoda(Distancias)
print('La solucion es:',sol)