import copy

def encolar(q, sol):
    i=0
    while i<len(q) and sol[0]>=q[i][0]:
        i+=1
    q = q[:i] + [sol] + q[i:]
    return q

def desencolar(q):
    return [q[0], q[1:]]

def crearColaVacia():
    return []

def esColaVacia(q):
    return q == []

def crearSolucionVacia(n):
    sol = [0]*n

    return sol

def calculaCoste(sol,Distancias):
    n = len(Distancias)
    paso = sol[2]
    tupla = sol[1]
    longitud = 0
    for i in range(0,paso-1):
        longitud += Distancias[tupla[i]][tupla[i+1]]
    estimacion = 0
    if (paso == n):
        longitud += Distancias[tupla[paso-1]][0]
    else:
        for i in range (n):
            if i not in tupla[0:paso]:
                estimacion += min(Distancias[i])
        estimacion += min(Distancias[0])
    sol[0] = longitud +estimacion
    return sol

def seleccionarNodo(sol,candidatos,Distancias):
    ultimoNodo = sol[1][sol[2]-1]
    nodoMejor = candidatos[0]
    distNodoMejor = Distancias[nodoMejor][ultimoNodo]
    indiceNodoMejor = 0
    for i in range (1,len(candidatos)):
        if Distancias[ultimoNodo][candidatos[i]]<distNodoMejor:
            nodoMejor = candidatos[i]
            indiceNodoMejor = i
            distNodoMejor = Distancias[ultimoNodo,candidatos[i]]
    del candidatos[indiceNodoMejor]
    return [nodoMejor,candidatos]

def SolucionInicialVoraz(Distancias):
    # sol va a ser una lista con [coste,tupla,longitud]
    n = len(Distancias)
    sol = [0, crearSolucionVacia(n), 1]
    candidatos = list(range(1,n))
    while candidatos != []:
        [nodoSig, candidatos] = seleccionarNodo(sol,candidatos,Distancias)
        sol[1][sol[2]] = nodoSig
        sol[2] += 1
    sol = calculaCoste(sol,Distancias)
    return sol

def GenerarTuplaVacia(Distancias):
    # sol va a ser una lista con [coste,tupla,longitud]
    n = len(Distancias)
    sol = [0, crearSolucionVacia(n), 1]
    sol = calculaCoste(sol, Distancias)
    return sol

def esSolucion(sol,n):
    return sol[2] == n

def esMejor(sol1, sol2):
    return sol1[0] < sol2[0]

def compleccionesFactibles(sol,Distancias):
    n = len(Distancias)
    hijos =[]
    for nodo in range(n):
        if nodo not in sol[1]:
            hijo = copy.deepcopy(sol)
            hijo[1][hijo[2]] = nodo
            hijo[2] += 1
            hijo = calculaCoste(hijo,Distancias)
            hijos.append(hijo)
    return hijos

def RamificacionYPoda(Distancias):
    n = len(Distancias)
    solMejor = SolucionInicialVoraz(Distancias) # Algoritmo voraz
    sol = GenerarTuplaVacia(Distancias) # Tupla parcial inicialmente vacía
    q = crearColaVacia()
    q = encolar(q, sol) # se añade la sol inicial
    while not esColaVacia(q):
        [sol, q] = desencolar(q) # Sol es el nodo de prioridad max
        if esSolucion(sol,n):
            if esMejor(sol, solMejor):
                solMejor = sol # Se actualiza SolMejor
        else:
            if esMejor(sol, solMejor): # Criterio de poda
                hijos = compleccionesFactibles(sol,Distancias)
                for hijo in hijos:
                    if esMejor(hijo, solMejor):
                        q = encolar(q,hijo)
    return solMejor

# Prog Ppal:
Distancias = [[999999,     5,      7.07, 16.55, 15.52,    18],
                       [5,     999999,         5, 11.70, 11.05, 14.32],
                       [7.07,  5,         999999,    14, 14.32, 18.38],
                       [16.55, 11.70,    14,     999999,     3,   7.6],
                       [15.52, 11.05, 14.32,     3,     999999,     5],
                       [18,    14.32, 18.38,   7.6,     5,     999999]]
sol = RamificacionYPoda(Distancias)
print('La solucion es:',sol)