import numpy as np

def calculaSkyline(inputData,ini,fin):
    if ini == fin: # Caso base: 1 edificio. Ponemos el edificio en formato de skyline:
        skyline = [[inputData[ini][0], inputData[ini][2]], [inputData[ini][1], 0]]
    else:
        mitad = (ini + fin) // 2
        skyline1 = calculaSkyline(inputData, ini, mitad)
        skyline2 = calculaSkyline(inputData, mitad+1, fin)
        skyline = mezclaSkyline(skyline1,skyline2)
    return skyline

def mezclaSkyline(skyline1,skyline2):
    skyline = []
    alturaPrevia1 = 0
    alturaPrevia2 = 0
    while not (skyline1 == [] or skyline2 == []):
        if skyline1[0][0] < skyline2[0][0]:
            alturaMax = skyline1[0][1]
            if alturaMax < alturaPrevia2:
                alturaMax = alturaPrevia2
            alturaPrevia1 = skyline1[0][1]
            skyline.append([skyline1[0][0], alturaMax])
            del skyline1[0]
        elif skyline1[0][0] > skyline2[0][0]:
            alturaMax = skyline2[0][1]
            if alturaMax < alturaPrevia1:
                alturaMax = alturaPrevia1
            alturaPrevia2 = skyline2[0][1]
            skyline.append([skyline2[0][0], alturaMax])
            del skyline2[0]
        else:
            alturaMax = max(skyline1[0][1], alturaMax = skyline2[0][1])
            skyline.append([skyline1[0][0], alturaMax])
            alturaPrevia1 = skyline1[0][1]
            alturaPrevia2 = skyline2[0][1]
            del skyline1[0]
            del skyline2[0]
    while skyline1 != []:
        skyline.append([skyline1[0][0], skyline1[0][1]])
        del skyline1[0]
    while skyline2 != []:
        skyline.append([skyline2[0][0], skyline2[0][1]])
        del skyline2[0]
    return skyline


# Prog Ppal:
inputData = [[7,10,3], [9,12,7], [1,4,10], [3,8,5], [11,13,10]]
print(inputData)
skyline = calculaSkyline(inputData,0,len(inputData)-1)
print('-----------')
print(skyline)