import numpy as np

def seleccionar(nodoyDist):
    iMin = 0
    seleccionado = nodoyDist[0][:]
    for i in range(1,len(nodoyDist)):
        if nodoyDist[i][1] < seleccionado[1]:
            iMin = i
            seleccionado = nodoyDist[i][:]
    del nodoyDist[iMin]
    return [seleccionado, nodoyDist]

def actualizarDist(grafo,nodoyDist,seleccionado):
    for i in range(len(nodoyDist)):
        nodoyDist[i][1] = min(nodoyDist[i][1],seleccionado[1]+grafo[seleccionado[0],nodoyDist[i][0]])
    return nodoyDist

def Dijkstra(grafo,nodoOrigen):
    longCaminos = np.copy(grafo[nodoOrigen,:])
    # Generamos la lista de distancias:
    nodoyDist=[]
    for i in range(len(grafo)):
        if i != nodoOrigen:
            nodoyDist.append([i, grafo[nodoOrigen,i]])
    # Bucle voraz:
    for i in range(len(grafo)-1):
        [seleccionado,nodoyDist] = seleccionar(nodoyDist)
        longCaminos[seleccionado[0]]=seleccionado[1]
        nodoyDist = actualizarDist(grafo,nodoyDist,seleccionado)
    return longCaminos

# Prog Ppal:
grafo = np.array([[0, 5, np.inf, 3, np.inf],[np.inf, 0, np.inf, np.inf, 2], [np.inf, np.inf, 0, np.inf, np.inf ],[np.inf,  1, 11, 0, 6],[np.inf, np.inf, 1, np.inf, 0]])
longCaminos = Dijkstra(grafo,3)
print(grafo)
print(longCaminos)
