import numpy as np

def ordenar(coleccion):
    for j in range(1,len(coleccion)):
        clave = np.copy(coleccion[j][:])
        # Insertar la clave en la secuencia ordenada:
        i = j - 1
        while i >= 0 and coleccion[i][2] < clave[2]:
            coleccion[i + 1][:] = np.copy(coleccion[i][:])
            i = i - 1
        coleccion[i+1][:] = np.copy(clave[:])
    return coleccion


def planificacion(tareas):
    # tareas es una lista de ternas [id, f, b]
    tareas = ordenar(tareas) # ordenamos decrecientemente por beneficio
    fechaMax = np.max(tareas[:,1])
    solucion = np.zeros(fechaMax)
    for i in range(len(tareas)):
        k = min(fechaMax,tareas[i,1])-1
        huecoEncontrado = False
        while k >= 0 and not huecoEncontrado:
            if solucion[k]==0:
                solucion[k] = tareas[i,0]
                huecoEncontrado = True
            else:
                k = k - 1
    return solucion

# Prog Ppal:
# Entrada
tareas = np.array([[1,2,60],[2,1,100],[3,3,20],[4,2,40],[5,1,20]])
solucion = planificacion(tareas)
print(solucion)
